#!/usr/bin/X11/tixwish


proc printCal { win } {
    global can selPrinter cputype printMode

#    puts "print 2 file : $file -> $selPrinter"
    if {$printMode == "c" } {
	set file [format "/tmp/kapa-%d-%d.ps" [pid] [currentTime] ]
	$can postscript -colormode gray -file $file -rotate 1  -pageheight  19.0c -pagey 1.5c -pagex 1.5c -pageanchor nw
    } else  {
	set file [format "/tmp/kapa-%d-%d" [pid] [currentTime] ]
	pack $win
	wm transient .pr ""
	wm iconify .pr
	wm geometry .pr 600x920
	update
	fillPrintCanvas $win $file
	set file "$file.ps"
#	update
#	$win  postscript  -colormode mono -file $file  -pagewidth  19.0c  -pagey 2c -pageanchor s
    }
    #FIXME fr Release wieder rausnehmen
    if { $cputype != "ppc" } {
	set ret [exec lpr -P$selPrinter $file]
    } else {
	set ret [exec gv -media a4  $file &]
    }
#    puts $ret
}
proc fillPrintCanvas {win bfile} {
    global cur_Cal groupOnlyCommon username showIgnore ignoreInfo
    global bfnt12 fnt12 fnt10
    global userList groupList roomList partStatusStr
    global prStartD prStartM prStartY prStopD prStopM prStopY

#FIXME eingabe
    set first [format "%04d%02d%02d" $prStartY $prStartM $prStartD]
    set last  [format "%04d%02d%02d" $prStopY $prStopM $prStopD]
#    puts "\n\n\ngetting calList for $first $last"
    set calList [request getUserCal $username  $cur_Cal $first $last  $showIgnore $ignoreInfo [expr 1 - $groupOnlyCommon]]
    if { [string first $calList "ServerDown"] >=0 } {ServerDownDialog}


    set file "$bfile-0.ps"
    set fileList ""
    set fc 0
    set y 2
    set dy 18
    set dy2 4
    set dy3 12
    set lc 0
 #   puts "calList = '$calList'\n\n"
    set calList [lsort -command compareCalEntries2 $calList]
  #  puts "calList = '$calList'\n\n"
    openMeter "Printing" "Bereite Ausdruck vor"
    set anz [llength $calList]
  #  puts "<$anz>"
    foreach date $calList { 
	updateMeter [expr int(floor(double($lc)/$anz*100)) ] "Bereite Ausdruck vor"
 	set did    [lindex $date 6]
	set startD [lindex $date 0]
#	puts ">> $did $startD"
	set ret [ request getBriefDate $username $did $startD ]
 	set titel [lindex $ret 1]
 	set startD [lindex $ret 2]
 	set startT [lindex $ret 3]
 	set stopD  [lindex $ret 4]
 	set stopT  [lindex $ret 5]
 	set room  [lindex $ret 6]
 	set details [lindex $ret 7]
 	set priv ""
 	if { [lindex $ret 9] == 1} { set priv "gruppeninterner Termin"}
 	if { [lindex $ret 8] == 1} { set priv "privater Termin "}
 	set part [lindex $ret 10]
 	set group [lindex $ret 11]
 	set repTyp [lindex $ret 12]
 	set noTime [lindex $ret 13]

 	set m0 [expr $startT %100]
 	set h0 [expr ($startT -$m0 ) /100 ]
 	set m1 [expr $stopT %100]
 	set h1 [expr ($stopT -$m0 ) /100 ]
 	set uList ""
 	foreach ent $part {
 	    set name  [ lindex $ent 1]
 	    set stat  [ lindex $ent 2]
 	    set ugType [ lindex $ent 3]
 	    set uList [format "%s%s (%s), " $uList $name [lindex $partStatusStr $stat]]
 	}
	if {$noTime == 1} {
	    $win create text 2 $y -font $fnt12 -text [format "%s" [date2lstr $startD] ] -anchor nw
	    $win create text 102 $y -font $fnt12 -text [format "-  %s" [date2lstr $stopD] ] -anchor nw
	} else {
	    $win create text 2 $y -font $fnt12 \
		-text [format "%s, %2d:%02d" [date2lstr $startD] $h0 $m0 ] -anchor nw
	    $win create text 102 $y -font $fnt12 \
		-text [format "-  %s, %2d:%02d" [date2lstr $stopD] $h1 $m1] -anchor nw
	}
 	$win create text 220 $y -font $bfnt12  -text  [strTrunc  $titel 45 ] -anchor nw



 	incr y $dy3
 	$win create text 160 $y -font $fnt10 -text "Ort " -anchor nw
 	$win create text 220 $y -font $fnt10 -text $room    -width 320 -anchor nw 
 	incr y $dy3
 	$win create text 160 $y -font $fnt10 -text "Details: " -anchor nw
 	$win create text 220 $y -font $fnt10 -text $details -width 320 -anchor nw -tag o$lc
	set yl [ lindex [ $win bbox o$lc ] 3]
	while {$y< $yl } {incr y $dy3}

 	$win create text 160 $y -font $fnt10 -text "Teilnehmer: " -anchor nw
 	$win create text 220 $y -font $fnt10 -text $uList -width 320 -anchor nw -tag p$lc
	set yl [ lindex [ $win bbox p$lc ] 3]
	while {$y< $yl } {incr y $dy3}

 	if { $priv != "" } {
 	    $win create text 220 $y -font $fnt10 -text $priv -anchor nw
 	    incr y $dy3
 	}
#	incr y 1
 	$win create line 2 $y 538 $y
	incr y $dy2
	incr lc
	if { $y > 710 } {
	    update
	    $win  postscript  -colormode mono -file $file  -pagewidth  19.0c  -pagey 2c -pageanchor s
	    lappend fileList $file
	    incr fc
	    set file "$bfile-$fc.ps"
	    set y 2
	    $win delete all
	}
    }
    if {$y >2} {
	update
	$win  postscript  -colormode mono -file $file  -pagewidth  19.0c  -pagey 2c -pageanchor s
	lappend fileList $file
    }
    TeXTogether $bfile $fileList
    closeMeter
}

proc TeXTogether { bfile fileList } {
    
    set tfile [format "%s.tex" $bfile]

    set fid [open $tfile "w" ]
    puts $fid "\\documentclass\[12pt\]\{article\}"
    puts $fid "\\usepackage\{psfig\}"
    puts $fid "\\textheight275mm"
    puts $fid "\\textwidth 195mm"
    puts $fid "\\oddsidemargin-15mm"
    puts $fid "\\evensidemargin-15mm"
    puts $fid "\\topmargin-30mm"
    puts $fid ""
    puts $fid "\\begin\{document\}"
    puts $fid ""
    foreach file $fileList {
	puts $fid "\\psfig\{figure=$file\}"
	puts $fid "\\clearpage"
    }
    puts $fid "\\end\{document\}"
    close $fid
    set curPath [pwd]
    cd /tmp
    set bbfile [lindex [split $bfile /] end]
    set ret [exec latex $bbfile]
#    puts "LaTeX : $ret"
    catch {set ret [exec dvips $bbfile]}
#    puts "dvips : $ret"
    cd $curPath
    foreach file $fileList {
	file delete $file
    }
    
}

proc switch2CalTyp { typ} {
    global calTyp
    
    set calTyp $typ
    drawCal
}

proc jump2Today { } {
    global calTyp today thisWeekStartD thisWeekStartM thisWeekStartY tday tmon tyear
    global curDay curMon curYear
    
    switch  $calTyp  {
	d {
	    set curDay  $tday
	    set curMon  $tmon
	    set curYear $tyear
	}
	w {
	    set curDay  $thisWeekStartD
	    set curMon  $thisWeekStartM
	    set curYear $thisWeekStartY
	}
	m {
	    set curDay  $tday
	    set curMon  $tmon
	    set curYear $tyear
	}
    }
    drawCal
}

proc jump2DateDialog { } {
    global curDay curMon curYear
    displayYearCal $curDay $curMon $curYear
}
proc _jump2DateDialog { } {
    global curDay curMon curYear
    global sDay sMon sYear


    set sDay  $curDay
    set sMon  $curMon
    set sYear $curYear

    toplevel .j2d 

    frame .j2d.t -relief raised -bd 1
    frame .j2d.b 
    pack .j2d.t -side top -fill x
    pack .j2d.b -side top -fill x -pady 3

    frame .j2d.t.l -relief ridge -bd 2
    frame .j2d.t.d  -relief ridge -bd 2
    pack .j2d.t.l .j2d.t.d -side top -fill x

    label .j2d.t.l.l -text "Springe nach"
    pack .j2d.t.l.l -side left

    tixControl .j2d.t.d.d  -label ""  -min 0 -max 31 -integer 1 -options {  entry.width 2} -variable sDay -selectmode immediate -autorepeat true
    tixControl .j2d.t.d.m -options { entry.width 2} -label "." -min 0 -max 12 -integer 1 -variable sMon -selectmode immediate -autorepeat true
    tixControl .j2d.t.d.y -options { entry.width 4} -label "." -min 1999 -max 2100 -integer 1 -variable sYear -selectmode immediate -autorepeat true
    
    pack .j2d.t.d.d .j2d.t.d.m .j2d.t.d.y -side left
    

    button .j2d.b.abb -text "Abbruch" -command {closeWin .j2d}
    pack .j2d.b.abb -side left
    button .j2d.b.jmp -text "Sprung" -command {jump2Date}
    pack .j2d.b.jmp -side right

    centerWin .j2d 154 88
    update
#    puts [wm geometry .j2d]
    grab .j2d
}

proc jump2Date { } {
    global curDay curMon curYear curOffset calTyp
    global sDay sMon sYear

    closeWin .j2d

    set curDay  $sDay
    set curMon  $sMon
    set curYear $sYear

    if { $calTyp == "w" } {
	set shift  [ weekDayByDate $sDay $sMon $sYear]
	
	set ret [calcDate $sDay $sMon $sYear [expr -1* $shift]]
	
	set curDay  [lindex $ret 0]
	set curMon  [lindex $ret 1]
	set curYear [lindex $ret 2]
    }
    drawCal
}


proc drawCal { } {
    global calTyp groupByUsers canParent cur_Cal  groupList calDrawn can hbfnt xmax ysmax ymax
    global groupWeekView yOffAnz dateTagKO yScrollOn  calAllDayList
    global can canParent calUserName
    global gridTagKOList calAnz


#    puts "drawCal '$calTyp' $groupByUsers"
    set groupWeekView 0
    $can delete all

    switch  $calTyp  {
	d {
	    set calUserName(0) $cur_Cal
	    set gridTagKOList ""
	    set calAllDayList ""
	    drawDayGrid
	    setTagList 1 [llength $gridTagKOList]  [join $gridTagKOList]
	    drawUsersCalendar
	}
	w {
	    set gridTagKOList ""
	    set calUserName(0) $cur_Cal
	    if { $groupByUsers == 1 && [lsearch $groupList [string trim $cur_Cal]]>=0} {
		set groupWeekView 1

		set users [ request usersOfGroup $cur_Cal]
		if { [string first $users "ServerDown"] >=0 } {ServerDownDialog}
		if { [llength $users ] >1 } {
		    set yScrollOn 1
		    $canParent configure -scrollbar y
		}

		set keep_cur_Cal $cur_Cal
		if { $calDrawn == 1 } {
		    $can delete all
		}
		set i 0
		set dateTagKO ""
		set calAllDayList ""
		set calAnz 0
		foreach user $users {
		    drawWeekGroupGrid $i [lindex $user 1]
		    addUsersCalendar  [lindex $user 0]
		    set calUserName($i)  [lindex $user 0]
		    incr i
		}
		set dateTagKO [lsort $dateTagKO]
#		puts "dateTagKO: $dateTagKO"
#		puts [join $dateTagKO]
		setTagList 0 [llength $dateTagKO] [join $dateTagKO]

		

		set yOffAnz $i
		$can create text [expr $xmax /2] 4 -text "Kalender der Gruppe $keep_cur_Cal" -font $hbfnt -anchor n
		$canParent adjustscrollregion
		set cur_Cal $keep_cur_Cal
		setCurCalMenuTitel
		set calDrawn 1
		redrawMainCanvas
		_drawCurrentTime
	    } else {
		set calAllDayList ""
		drawWeekGrid
		drawUsersCalendar
	    }
	    setTagList 1 [llength $gridTagKOList]  [join $gridTagKOList]
	}
	m { 
	    set calUserName(0) $cur_Cal
	    set gridTagKOList ""
	    set calAllDayList ""
	    drawMonGrid
	    drawUsersCalendar
	    setTagList 1 [llength $gridTagKOList] [join $gridTagKOList]
	}
    }
    $canParent adjustscrollregion
}



# 
# Indizes: 
#          cid= calNr-ZeilenNr
#         lcid= calNr-ZielenNr-TagesNr
# 
# 
# Variable, die von cid abhgen
#         
#         yday0       : Oberkante des Kopfbereiches
#         yday1       : Oberkante des Kalenders
#         yday2       : Oberkante des eigentlichen Kalenders (ohne ganztgge Termine)
#         yTitelType  : Werte 'full' oder 'small', gibt an ob ein- oder zweizeile Spaltentitel verwendet werden
#         calStart    : Stunde zu der der Kalender beginnt (i.d.r  =0 ausser bei gesplitteten Kalendern)
#         calEnd      : Stunde zu der der Kalender endet (i.d.r  =24  ausser bei gesplitteten Kalendern)
#         calDayList  : Liste aller lcids zu einer cid
#         xLeftLegend : Linke X-koordinate der linken Zeitleiste
#         xRightLegend: Linke X-koordinate der rechten Zeitleiste
#         
#         
# Variable, die von lcid abhgen
#         
#         xday        : linke Kante des Tages
#         calDayStr   : String des Tages
#         calDay   \ 
#         calMon    | : zusammen das Dartum des Tages 
#         calYear  /
#         calWD       : Index des Wochentages des Tages
#         calSplitOffset : Offset im zweiten Teil eines gesplitteten Kalenders
#         
# Varibalen die vin calNr abhngen
#
#         calLineList : Liste mit allen cids
#         calUserName : name des Users des Calendes
#
# Variablen, die keine Arrays sind
#         dxd         : Breite eine Tages
#         dxs         : Breite der Zeitleiste
#         dyh         : Hhe einer Stunde
#         dyCal       : Hhe des Kalenders unter der Titelzeile
#         hourModulo  : Scrittweite der Stundenanzeige in der Zeitleiste
#         calHourLineStep : Zahl der Stunden pro Linie im Kalender
#         calLineAnz 
#         calJumpMode : w oder m je nachdem ob Monatskalender (m) oder nicht
#         calStrList    : Liste mit allen Tagesstrings in der Reiehnfolge
#         calAllDayList : Liste mit Listen, die die Zeilen und Tages indezied enyhalten,
#                               in derselben Reiehenfolge wie calStrList
#         calAllDayList2: wie calAllDayList, aber fr den zweiten Teil eine gesplitteten Kalenders
#         calNr       : Nummer des aktuellen Kalenders
#         calKernStart : Beginn der Kernzeit
#         calKernEnd   : End der Kernzeit
#         calKernEln  : Lnge der Kernzeit
#         calSplitHour : Stunde zu der der Kalender gesplittet wird
#         calAnz      :Anzahl der Kalender    
#         calGlobalSlots : Zahl der "Stunden" die fr ganztages Termine reserviert sind.

proc drawDayGrid {  } {
    global dyh dxd dxb dxs dyt wdList xday xday2 yday yday2 calDay calMon calYear calWD calDayCount
    global weekDays monlen monAbk
    global curDay curMon curYear curOffset 
    global yOffset xmax xmx ymax xbl xbr dyCal yOffList yOffList2 yOffAnz hourModulo yScrollOn
    global calKernStart calKernEnd calSplitHour calKernLen calGlobalSlots calSplitYPos
    global xLeftLegend xRightLegend xLeftLegend2 xRightLegend2 yLegend yLegend2 legendAnz
    global xday yday0 yday1 yday2 calDay calMon calYear calWD calStart calEnd calDayList yTitelType calLineAnz
    global calNr calDayStr calHourLineStep calLineList calJumpMode calAllDayList calAllDayList2 calStrList
    global calSplitOffset calUserName calAnz
    global uCalKernStart uCalKernEnd uGlobalSlotsD


     set day    $curDay
     set mon    $curMon
     set year   $curYear
#     set offset $curOffset
    set offset  [weekDayByDate $day $mon $year]

    set calKernStart $uCalKernStart
    set calKernEnd $uCalKernEnd
    set calKernLen [expr $calKernEnd -$calKernStart]
    set calGlobalSlots $uGlobalSlotsD

    set wdList ""
    set calDayCount 1
    set dyh 18

    set xmx [ expr $xmax - $yScrollOn *12 ]
    set dxd [ expr int(floor((double($xmx)/2.-84-8)))]
    set dxs [expr ($xmx/2 -$dxd-8)/2 ]

    set xoffset [expr ($xmx/2)+7]

    set xbl [expr $dxs -1]
    set xbr [expr $xbl + $calDayCount *$dxd ]
    set dxb 20
    set dyt 32
    set yOffset 0
    set yOffAnz 1
    set hourModulo 1


    set slots [expr 24+($calKernEnd-$calKernStart)]
    if { [ expr $slots %2] == 1} {
	incr slots
	incr calGlobalSlots
    }
    set slots1 [expr $slots /2]
    set kslots [ expr $slots1 - $calGlobalSlots -$calKernStart]
    if { [ expr $kslots %2] == 1} {
	incr slots 2
	incr calGlobalSlots 2
	set slots1 [expr $slots /2]
	set kslots [ expr $slots1 - $calGlobalSlots -$calKernStart]
    }
    set dyh [ expr int (floor((double($ymax)-$dyt)/$slots1))]
    set calSplitHour [ expr $calKernStart +($kslots/2)]
#    puts "$calKernStart & $kslots  -> $calSplitHour"
    set calSplitYPos [ expr ($kslots + $calKernStart) *$dyh]
    set dyCal [ expr $slots1 * $dyh]
#    set calSplitHour 24

    set wdList ""
    set calDayCount 1
#    set calDayList ""


    set hourModulo 1
    set calHourLineStep 1
    set calLineAnz 1
    set legendAnz 1
    set calJumpMode "w"
    set calStrList ""

    set cid "0-0"
    set lcid "0-0-0"
    set yday0($cid) 0
    set yday1($cid) $dyt
    set yday2($cid) [expr $dyt +$calGlobalSlots *$dyh]
    set yTitelType($cid) "full"
    set calStart($cid) 0
    set calEnd($cid) 12
    set calDayList($cid) ""
    set xday($lcid) $dxs
    set dstr [format "%4d%02d%02d" $year $mon $day ] 
    lappend calStrList $dstr
    set calDayStr($lcid) $dstr
    set calDay($lcid)  $day
    set calMon($lcid)  $mon
    set calYear($lcid) $year
    set calWD($lcid)   [expr $offset % 7 ]
    lappend calDayList($cid) $lcid
    lappend calAllDayList "0 0"
    set xLeftLegend($cid)   [expr $xday(0-0-0) -$dxs]
    set xRightLegend($cid)  [expr $xday(0-0-0) + $dxd ]
    set calSplitOffset($lcid) 0

    set cid "0-1"
    set lcid "0-1-0"
    set yday0($cid) 0
    set yday1($cid) $dyt
    set yday2($cid) $dyt
    set yTitelType($cid) "full"
    set calStart($cid) 12
    set calEnd($cid) 24
    set calDayList($cid) ""
    set xday($lcid) [ expr $dxs+ $xoffset ]
    set dstr [format "%4d%02d%02d" $year $mon $day ] 
    set calDayStr($lcid) $dstr
    set calDay($lcid)  $day
    set calMon($lcid)  $mon
    set calYear($lcid) $year
    set calWD($lcid)   [expr $offset % 7 ]
    lappend calDayList($cid) $lcid
    lappend calAllDayList2 "1 0"
    set xLeftLegend($cid)   [expr $xday(0-1-0) -$dxs]
    set xRightLegend($cid)  [expr $xday(0-1-0) + $dxd ]
    set calSplitOffset($lcid) [expr ($slots1 - $calGlobalSlots)  *$dyh]

    set calNr 0
    set calLineList(0) " 0-0 0-1"
    set calAnz 1

    set yOffList(0) $yday2(0-0)
    set yOffList2(0) $yday1(0-0)
    drawCalGrid 
}


proc drawWeekGrid {  } {
    global dyh dxd dxb dxs dyt wdList xday xday2 yday yday2 calDay calMon calYear calWD calDayCount
    global weekDays monlen monAbk
    global curDay curMon curYear curOffset 
    global yOffset xmx xmax ymax xbl xbr canParent dyCal yOffList yOffList2 yOffAnz hourModulo yScrollOn
    global calKernStart calKernEnd calKernLen calSplitHour calGlobalSlots calSplitYPos

    global xLeftLegend xRightLegend xLeftLegend2 xRightLegend2 yLegend yLegend2 legendAnz
    global xday yday0 yday1 yday2 calDay calMon calYear calWD calStart calEnd  yTitelType calLineAnz
    global calNr calDayStr calHourLineStep calDayList calLineList calJumpMode calAllDayList calStrList
    global calSplitOffset calUserName calAnz
    global uCalKernStart uCalKernEnd uGlobalSlotsW
#    global day mon year

    set day    $curDay
    set mon    $curMon
    set year   $curYear
    set offset  [weekDayByDate $day $mon $year]

    set calKernStart $uCalKernStart
    set calKernEnd $uCalKernEnd
    set calKernLen [expr $calKernEnd -$calKernStart]
    set calGlobalSlots $uGlobalSlotsW
    set calSplitHour 25

    set wdList ""
    set calDayCount 7
    set xmx [ expr $xmax - $yScrollOn *16 ]
    set dxd [expr int(floor(double($xmx -76)/$calDayCount)) ]
    set dxs [expr ($xmx -$calDayCount *$dxd)/2 ]
#     set xbl [expr $dxs -1]
#     set xbr [ expr $xbl + $calDayCount *$dxd ]
    set dxb 20
    set yOffset 0
    set dyt 32
    set slots  [ expr $calKernLen +24 +$calGlobalSlots ]
    set dyh [expr int(floor(double($ymax-$dyt)/$slots))]
    set dyCal [expr $slots * $dyh]
#    puts "slots=$slots , $dyh $ymax"
    set yOffList(0) $yOffset
    set yOffAnz 1


    set hourModulo 1
    set calHourLineStep 1
    set calLineAnz 1
    set legendAnz 1
    set calJumpMode "w"

    set cid "0-0"
    set yday0($cid) 0
    set yday1($cid) $dyt
    set yday2($cid) [expr $dyt +$calGlobalSlots *$dyh]
    set yTitelType($cid) "full"
    set calStart($cid) 0
    set calEnd($cid) 24
    set calDayList($cid) ""

    set calStrList ""
    for { set i 0} { $i < $calDayCount } { incr i } {
	set lcid "0-0-$i"
	set xday($lcid) [ expr $dxs + $i *$dxd ]
	set calSplitOffset($lcid) 0
	set dstr [format "%4d%02d%02d" $year $mon $day ] 
	lappend calStrList $dstr
	lappend wdList $dstr
	set calDayStr($lcid) $dstr
	set calDay($lcid)  $day
	set calMon($lcid)  $mon
	set calYear($lcid) $year
	set calWD($lcid)   [expr ($i +$offset) % 7 ]
	lappend calDayList($cid) $lcid
	lappend calAllDayList "0 $i"
	
	incr day
	set extend 0
	if { $day > [lindex $monlen $mon] } {
	    if { $mon == 2} {
		if { [ expr $year % 4] == 4 } {
		    if { $day<=29 } { set extend 1} } }
	    if { $extend == 0 } { 
		incr mon
		set day 1
		if { $mon > 12 } {
		    incr year
		    set mon 1
		}
	    }
	}	
    }
    set xLeftLegend($cid)   0
    set xRightLegend($cid)  [expr $dxs +$calDayCount * $dxd]
    set yOffList(0) $yday2(0-0)
    set yOffList2(0) $yday1(0-0)
    set calNr 0
    set calLineList(0) " 0-0"
    set calAnz 1

    drawCalGrid 
    $canParent adjustscrollregion
}

proc drawWeekGroupGrid { idx full } {
    global dyh dxd dxb dxs dyt wdList xday xday2 yday yday2 calDay calMon calYear calWD calDayCount
    global weekDays monlen monAbk
    global curDay curMon curYear curOffset 
    global yOffset xmx xmax ymax xbl xbr canParent dyCal
    global can lbfnt
    global yOffList yOffList2 ysmax hourModulo yScrollOn
    global calKernStart calKernEnd calKernLen calSplitHour calGlobalSlots calSplitYPos

    global xLeftLegend xRightLegend xLeftLegend2 xRightLegend2 yLegend yLegend2 legendAnz
    global xday yday0 yday1 yday2 calDay calMon calYear calWD calStart calEnd  yTitelType calLineAnz
    global calNr calDayStr calHourLineStep calDayList calLineList calJumpMode calAllDayList calStrList
    global calSplitOffset calUserName calAnz
    global uGlobalSlotsWG

    set calNr $idx

    set day    $curDay
    set mon    $curMon
    set year   $curYear
    set offset  [weekDayByDate $day $mon $year]

    set calKernStart 25
    set calKernEnd 25
    set calKernLen [expr $calKernEnd -$calKernStart]
    set calGlobalSlots $uGlobalSlotsWG
#    set calGlobalSlots 2
    set calSplitHour 25


    set wdList ""
    set calDayCount 7
    set xmx [ expr $xmax - $yScrollOn *16 ]
#    puts "Xmax: $xmax -> $xmx"
    set dxd [expr int(floor(double($xmx -72)/$calDayCount)) ]
    set dxs [expr ($xmx -$calDayCount *$dxd)/2 ]
    set xbl [expr $dxs -1]
#    puts "$dxs $dxd"
    set dyh 12
    set slots  [ expr 24 +$calGlobalSlots ]
    set dyCal [expr $slots * $dyh]
    set yOffList($idx) $yOffset

    set hourModulo 2
    set calHourLineStep 1
#    set calLineAnz 1
#    set legendAnz 1
    set calJumpMode "w"

    set cid "$calNr-0"
    set yday0($cid) [expr 64+ $calNr * ($dyCal+$dyt+32) ]
    set yday1($cid) [expr $yday0($cid) +$dyt ]
    set yday2($cid) [expr $yday0($cid) +$dyt +$calGlobalSlots *$dyh]
    set yTitelType($cid) "full"
    set calStart($cid) 0
    set calEnd($cid) 24
    set calDayList($cid) ""

    set calStrList ""
    for { set i 0} { $i < $calDayCount } { incr i } {
	set lcid "$cid-$i"
	set calSplitOffset($lcid) 0
	set xday($lcid) [ expr $dxs + $i *$dxd ]
	set dstr [format "%4d%02d%02d" $year $mon $day ] 
	lappend calStrList $dstr
	lappend wdList $dstr
	set calDayStr($lcid) $dstr
	set calDay($lcid)  $day
	set calMon($lcid)  $mon
	set calYear($lcid) $year
	set calWD($lcid)   [expr ($i +$offset) % 7 ]
	lappend calDayList($cid) $lcid
	lappend calAllDayList "0 $i"


	incr day
	set extend 0
	if { $day > [lindex $monlen $mon] } {
	    if { $mon == 2} {
		if { [ expr $year % 4] == 4 } {
		    if { $day<=29 } { set extend 1} } }
	    if { $extend == 0 } { 
		incr mon
		set day 1
		if { $mon > 12 } {
		    incr year
		    set mon 1
		}
	    }
	}	
    }
    set calLineList($calNr) "$cid"
    set xLeftLegend($cid)   0
    set xRightLegend($cid)  [expr $dxs +$calDayCount * $dxd]
    incr calAnz

    $can create text [expr $xmx /2] [expr $yday0($cid) -2] -text "Kalender $full" -font $lbfnt -anchor s
    addCalGrid
    $canParent adjustscrollregion
}
proc drawMonGrid {  } {
    global dyh dxd dxb dxs dyt wdList xday xday2 yday yday2 calDay calMon calYear calWD calDayCount
    global weekDays monlen monAbk
    global curDay curMon curYear curOffset 
    global yOffset xmx xmax ymax xbl xbr canParent dyCal yOffList yOffList2 yOffAnz hourModulo yScrollOn
    global calKernStart calKernEnd calKernLen calSplitHour calGlobalSlots calSplitYPos

    global xLeftLegend xRightLegend xLeftLegend2 xRightLegend2 yLegend yLegend2 legendAnz
    global xday yday0 yday1 yday2 calDay calMon calYear calWD calStart calEnd  yTitelType calLineAnz
    global calNr calDayStr calHourLineStep calDayList calLineList calJumpMode calStrList calAllDayList
    global calUserName calSplitOffset calAnz
    global uGlobalSlotsW
#    global day mon year

    set day    1
    set mon    $curMon
    set year   $curYear
    set offset  [weekDayByDate $day $mon $year]

    set datum [ calcDate 1 $mon $year  [expr -1*$offset] ]
    set day  [lindex $datum 0]
    set mon  [lindex $datum 1]
    set year [lindex $datum 2]
    set offset  [weekDayByDate $day $mon $year]

#    puts "offset of $day.$mon is $offset"

    set calKernStart 25
    set calKernEnd 25
    set calKernLen [expr $calKernEnd -$calKernStart]
    set calGlobalSlots $uGlobalSlotsW
#    set calGlobalSlots 3
    set calSplitHour 25

    set wdList ""
    set calDayCount 7
    set xmx [ expr $xmax - $yScrollOn *16 ]
    set dxd [expr int(floor(double($xmx -76)/7)) ]
    set dxs [expr ($xmx -7 *$dxd)/2 ]
#    set dxb 20
#    set yOffset 0
    set dyt 16
    set slots  [ expr 24 +$calGlobalSlots ]
    set dyh [expr int(floor(double($ymax-$dyt)/$slots/5))]
    set dyCal [expr $slots * $dyh]
    set yh [expr $dyCal +$dyt]
#    puts "slots=$slots , $dyh $ymax"
    set yOffList(0) $yOffset
    set yOffAnz 1


    set hourModulo 4
    set calHourLineStep 2
    set calLineAnz 1
    set legendAnz 1
    set calJumpMode "m"
    set calLineList(0) ""

    for {set l 0} { $l <5 } {incr l} {
	set cid "0-$l"
	set y0 [expr $l *$yh ]
	set yday0($cid) $y0
	set yday1($cid) [expr $y0 + $dyt]
	set yday2($cid) [expr $y0 + $dyt +$calGlobalSlots *$dyh]
	set yTitelType($cid) "small"
	set calStart($cid) 0
	set calEnd($cid) 24
	set calDayList($cid) ""
	set xLeftLegend($cid)   0
	set xRightLegend($cid)  [expr $dxs +7*$dxd]
	lappend calLineList(0)  $cid
	set calDayList($cid) ""
    }

    set l 0
    set cid "0-$l"
#    set calDayCount [ lindex $monlen $mon]

#    puts ">>>>>>>>>>>>>>$calAllDayList<<"
    set calStrList ""
    for { set i 0} { $i < 35 } { incr i } {
	set wd [expr ($i +$offset) % 7 ]
	if {$wd == 0 && $i >0 } {
	    incr l
	    set cid "0-$l"
	}
	set lcid "$cid-$i"
	set xday($lcid) [ expr $dxs + $wd *$dxd ]
	set calSplitOffset($lcid) 0
	set dstr [format "%4d%02d%02d" $year $mon $day ] 
	lappend calStrList $dstr
	lappend wdList $dstr
	set calDayStr($lcid) $dstr
	set calDay($lcid)  $day
	set calMon($lcid)  $mon
	set calYear($lcid) $year
	set calWD($lcid)   $wd
	lappend calDayList($cid) $lcid
	lappend calAllDayList "$l $i"
	
	incr day
	set extend 0
	if { $day > [lindex $monlen $mon] } {
	    if { $mon == 2} {
		if { [ expr $year % 4] == 4 } {
		    if { $day<=29 } { set extend 1} } }
	    if { $extend == 0 } { 
		incr mon
		set day 1
		if { $mon > 12 } {
		    incr year
		    set mon 1
		}
	    }
	}	
    }
#    puts ">>>>>>>>>>>>>>$calAllDayList<<"
    set yOffList(0) $yday2(0-0)
    set yOffList2(0) $yday1(0-0)
    set calNr 0
    set calAnz 1
    drawCalGrid 
    $canParent adjustscrollregion
}

proc drawCalGrid {  } {
    global can calDrawn

    
    if { $calDrawn == 1 } {
	$can delete termin
	update
    }

    addCalGrid
}
    
proc addCalGrid {  } {
    global can xmx ymax dxs xbl xbr dyCal hourModulo
    global xday xday2 yday dyt yday2
    global weekDays weekDaysAbk monlen monAbk
    global wdList dxd dyh dxb xday  calDay calMon calYear calWD calDayCount
    global calDrawn  today 
    global yOffset pfnt pfnt12 fnt fnt12  
    global calKernStart calKernEnd calSplitHour calGlobalSlots calKernLen
    global xoffset calSplitYoffset 
    global xLeftLegend xRightLegend xLeftLegend2 xRightLegend2 yLegend yLegend2 legendAnz
    global xday yday0 yday1 yday2 calDay calMon calYear calWD calStart calEnd calDayList calLineAnz yTitelType
    global calNr calDayStr calHourLineStep calLineList calJumpMode 
    global gridTagKOList
    global holidays holidayNames holidayMonth

#     $can create rectangle 1 [expr $yOffset +1] $xmx [expr $yOffset + $dyCal] -fill grey90 -outline grey65

    foreach cid $calLineList($calNr) {
    #Zeittafeln
#	puts "cl: $cid:  $xRightLegend($cid) $yday0($cid) $yday2($cid) $dyh $calKernStart $calKernEnd"
	if { $xLeftLegend($cid) >=0 } {
	    set x0 [ expr $xLeftLegend($cid)]
	    set x1 [ expr $x0 +$dxs]
	    set x2 [ expr $x0 +$dxs -2]
	    set y  $yday0($cid)
	    $can create line $x0 $y $x1 $y 
	    set y  $yday1($cid)
	    $can create line $x0 $y $x1 $y 
	    set y  $yday2($cid)
	    $can create line $x0 $y $x1 $y 
	    $can create line $x0 [expr $y-1] $x1 [expr $y-1]
	    for { set h [expr $calStart($cid)+1] } {$h <= $calEnd($cid)} {incr h } {
		incr y $dyh
		if { $calKernStart < $h && $h <= $calKernEnd } {
		    incr y $dyh
		}	    
		set yt [expr $y +2]
		if { [expr $h % $hourModulo] == 0} {
		    $can create text $x2 $yt -anchor se -text [format "%2d:00" $h ] -font $fnt12
		    $can create line $x0 $y $x1 $y 
		}
	    }
	    $can create line $x0 $yday0($cid) $x0 [expr $yday1($cid)+$dyCal] 
	    $can create line $x1 $yday0($cid) $x1 [expr $yday1($cid)+$dyCal] 
	    
	    set x1 [expr $x0 +3]
	    set x2 [expr $x0 +$dxs -1 ]
	    set xs [expr ($x1+$x2)/2 ]
	    set y0 $yday0($cid)
	    set y1 [expr $y0 +3]
	    set y2 [expr $y0 +16]
	    set y3 [expr $y0 +18]
	    set y4 [expr $y0 +31]
	    if { $calJumpMode == "w" } {
		rButton $can $x1 $y1 $x2 $y2 dayBack
		rButton $can $x1 $y3 $x2 $y4 weekBack
		$can create text $xs $y2 -anchor s -text "<"   -tag dayBack
		$can create text $xs $y4 -anchor s -text "<<<" -tag weekBack
		$can bind dayBack   <ButtonRelease> { changeDate -1 }
		$can bind weekBack  <ButtonRelease> { changeDate -7 }
	    } elseif { $calJumpMode == "m" } {
		rButton $can $x1 $y1 $x2 $y2 monthBack
		$can create text $xs $y2 -anchor s -text "<<<<"   -tag monthBack
		$can bind monthBack   <ButtonRelease> { changeDateByMonth -1 }
	    }
	}
	if { $xRightLegend($cid) >=0 } {
	    set x0 [ expr $xRightLegend($cid)]
	    set x1 [ expr $x0 +$dxs]
	    set x2 [ expr $x0 +$dxs -3]
	    set y  $yday0($cid)
	    $can create line $x0 $y $x1 $y 
	    set y  $yday1($cid)
	    $can create line $x0 $y $x1 $y 
	    set y  $yday2($cid)
	    $can create line $x0 $y $x1 $y 
	    $can create line $x0 [expr $y-1] $x1 [expr $y-1]
	    for { set h [expr $calStart($cid)+1] } {$h <= $calEnd($cid)} {incr h  } {
		incr y $dyh
		if { $calKernStart < $h && $h <= $calKernEnd } {
		    incr y $dyh
		}	    
		set yt [expr $y +2]
		if { [expr $h % $hourModulo] == 0} {
		    $can create text $x2 $yt -anchor se -text [format "%2d:00" $h ] -font $fnt12
		    $can create line $x0 $y $x1 $y 
		}
	    }
	    incr x1 -1
	    $can create line $x0 $yday0($cid) $x0 [expr $yday1($cid)+$dyCal] 
	    $can create line $x1 $yday0($cid) $x1 [expr $yday1($cid)+$dyCal] 
	    set x1 [expr $x0 +1]
	    set x2 [expr $x0 +$dxs -3 ]
	    set xs [expr ($x1+$x2)/2 ]
	    set y0 $yday0($cid)
	    set y1 [expr $y0 +3]
	    set y2 [expr $y0 +16]
	    set y3 [expr $y0 +18]
	    set y4 [expr $y0 +31]
	    if { $calJumpMode == "w" } {
		rButton $can $x1 $y1 $x2 $y2 dayForw
		rButton $can $x1 $y3 $x2 $y4 weekForw
		$can create text $xs $y2 -anchor s -text ">"   -tag dayForw
		$can create text $xs $y4 -anchor s -text ">>>" -tag weekForw
		$can bind dayForw   <ButtonRelease> { changeDate 1 }
		$can bind weekForw  <ButtonRelease> { changeDate 7 }
	    } elseif { $calJumpMode == "m" } {
		rButton $can $x1 $y1 $x2 $y2 monthForw
		$can create text $xs $y2 -anchor s -text ">>>>"   -tag monthForw
		$can bind monthForw   <ButtonRelease> { changeDateByMonth 1 }
	    }
	}


	foreach lcid $calDayList($cid) {
#	    puts "ID: $cid / $lcid"

	    #senkrechte Einteilung
	    set y0 [expr $yday0($cid)]
	    set y1 [expr $y0 + 17]        
	    set y2 [expr $y0 + 32]
	    set y3 $yday1($cid)
	    set y4 $yday2($cid)
	    set yl [expr $yday1($cid) +$dyCal ]
	
	    set x  $xday($lcid)
	    set x1 [ expr $x +$dxd/2] 
	    set x3 [ expr $x +$dxd -1]
	    set dstr $calDayStr($lcid)

	    set WDstr [lindex $weekDays $calWD($lcid) ]
	    set mtag [format "%04d-%02d" $calYear($lcid) $calMon($lcid) ]
	    set holiday 0
	    if { [lsearch $holidayMonth $mtag] >=0 } {
		set i [lsearch $holidays($mtag) $calDay($lcid)]
		if { $i >=0} {
		    set WDstr [lindex $holidayNames($mtag) $i]
		    set holiday 1
		}
	    }

	    if { $today == $dstr } {
		if { $y4 > $y3} {
		    $can create rectangle $x $y3 $x3 $y4 -fill PeachPuff -outline PeachPuff  -tag gd$lcid
		    $can create rectangle $x $y4 $x3 $yl -fill PapayaWhip -outline PapayaWhip  -tag wd$lcid
		    lappend gridTagKOList "gd$lcid $x $y3 $x3 $y4"
		    lappend gridTagKOList "wd$lcid $x $y4 $x3 $yl"
		    $can bind gd$lcid <ButtonRelease> { canAddDate %x %y}
		} else {
		    $can create rectangle $x $y3 $x3 $yl -fill PapayaWhip  -outline PapayaWhip  -tag wd$lcid
		    lappend gridTagKOList "wd$lcid $x $y3 $x3 $yl"

		}

		if { $yTitelType($cid) == "full" } {
		    if { $holiday == 0 } {
			$can create rectangle $x $y0 $x3 $y2 -fill ivory -outline ivory
		    } else { 
			$can create rectangle $x $y0 $x3 $y2 -fill DarkOliveGreen3 -outline DarkOliveGreen3
		    }
		    $can create text $x1 $y1 -anchor s -tag jt$lcid -text $WDstr -fill red4
		    $can create text $x1 $y2 -anchor s  -tag jt$lcid -fill red4 \
		    -text [format  "%2d.%4s %4d" $calDay($lcid) [lindex $monAbk $calMon($lcid)] $calYear($lcid) ]
		    lappend gridTagKOList "jt$lcid $x $y0 $x3 $y2"
		} else {
		    $can create rectangle $x $y0 $x3 $y1 -fill ivory -outline ivory
		    $can create text $x1 $y1 -anchor s  -tag jt$lcid -fill red4 \
			-text [format  "%2s, %2d.%4s %4d" [lindex $weekDaysAbk $calWD($lcid)]\
				   $calDay($lcid) [lindex $monAbk $calMon($lcid)] $calYear($lcid) ]
		    lappend gridTagKOList "jt$lcid $x $y0 $x3 $y1"
		}

		$can create line $x  $y0 $x $yl -fill black -tag wd$lcid
	    } else {
		if { $y4 > $y3} {
		    $can create rectangle $x $y3 $x3 $y4 -fill grey80 -outline grey90  -tag gd$lcid
		    $can create rectangle $x $y4 $x3 $yl -fill grey95 -outline grey95  -tag wd$lcid
		    lappend gridTagKOList "gd$lcid $x $y3 $x3 $y4"
		    lappend gridTagKOList "wd$lcid $x $y4 $x3 $yl"
		    $can bind gd$lcid <ButtonRelease> { canAddDate %x %y}
		} else {
		    $can create rectangle $x $y3 $x3 $yl -fill grey95 -outline grey95  -tag wd$lcid
		    lappend gridTagKOList "wd$lcid $x $y3 $x3 $yl"
		}
		if { $yTitelType($cid) == "full" } {
		    if { $holiday == 0 } {
			$can create rectangle $x $y0 $x3 $y2 -fill grey98 -outline grey98
		    } else { 
			$can create rectangle $x $y0 $x3 $y2 -fill DarkOliveGreen3 -outline DarkOliveGreen3
		    }
		    $can create text $x1 $y1 -tag jt$lcid -anchor s -text $WDstr
		    $can create text $x1 $y2 -tag jt$lcid -anchor s \
		    -text [format  "%2d.%4s %4d" $calDay($lcid) [lindex $monAbk $calMon($lcid)] $calYear($lcid) ]
		    lappend gridTagKOList "jt$lcid $x $y0 $x3 $y2"
		} else {
		    $can create rectangle $x $y0 $x3 $y1 -fill grey98 -outline grey98
		    $can create text $x1 $y1 -tag jt$lcid -anchor s \
			-text [format  "%2s, %2d.%4s %4d" [lindex $weekDaysAbk $calWD($lcid)]\
				   $calDay($lcid) [lindex $monAbk $calMon($lcid)] $calYear($lcid) ]
		    lappend gridTagKOList "jt$lcid $x $y0 $x3 $y1"
		}

		$can create line $x  $y0 $x $yl -fill black  -tag wd$lcid
	    }

	#StundLinien
	    set y  $yday0($cid)
	    $can create line $x $y $x3 $y 
	    set y  $yday1($cid)
	    $can create line $x $y $x3 $y 
	    set y  $yday2($cid)
	    $can create line $x $y $x3 $y 
	    $can create line $x [expr $y-1] $x3 [expr $y-1]
	    set dy [expr $dyh * $calHourLineStep]
	    for { set h [expr $calStart($cid)+1] } {$h <= $calEnd($cid)} {incr h $calHourLineStep } {
		incr y $dy
		if { $calKernStart < $h && $h <= $calKernEnd } {
		    incr y $dy
		}	    
		$can create line $x $y $x3 $y   -tag wd$cid
	    }
	    #
	    $can bind wd$lcid <ButtonRelease> { canAddDate %x %y}
	    $can bind jt$lcid <ButtonRelease> { canAddDate %x %y}

	}
    }
}

proc drawCalendarList { } {
    global kalWin cur_Cal selCalObj bfnt12
    global userList groupList roomList  fullUserNames
    global calUserList

    check4NewLists

    menu $selCalObj.menu -font $bfnt12 -tearoff 0 -disabledforeground black
    menu $selCalObj.menu.group -font $bfnt12 -tearoff 0
    menu $selCalObj.menu.rooms -font $bfnt12 -tearoff 0
    
    $selCalObj.menu add cascade -label "Gruppen: " -menu $selCalObj.menu.group
    $selCalObj.menu add cascade -label "Rume: " -menu $selCalObj.menu.rooms
    $selCalObj.menu add command -label "Mitarbeiter: " -state disabled 
    
    set menuWidth 20

    set lc 3
    set curMenu $selCalObj.menu
    set mid 0
    update

    set anz [llength $userList]
    for {set i 0} {$i < $anz} {incr i } {
	set user [lindex $userList $i]
	set name [nameStrTrunc $fullUserNames(u-$user) $menuWidth]
	set calUserList($name) $user
	$curMenu add command -label  "  $name" -command setCurCal
	if { $lc >40 } {
	    if { [expr $i+1] <$anz } {
		incr mid
		set newMenu  $selCalObj.menu.sub$mid
		$curMenu add cascade -label "weitere Mitarbeiter:" -menu $newMenu
		set curMenu $newMenu
		#	    puts "next Menu $curMenu"
		menu $curMenu -font $bfnt12 -tearoff 0
		set lc 0
	    }
	}
	update
	incr lc
    }

    set lc 0
    set curMenu $selCalObj.menu.group
    set mid 0
    set anz [llength $groupList]
    set i 0
    foreach group $groupList { 
	set name [nameStrTrunc $group $menuWidth]
	set calUserList($name) $group
	$curMenu add command -label "  $name" -command setCurCalGroup
	if { $lc >40 } {
	    if { [expr $i+1] <$anz } {
		incr mid
		$curMenu add cascade -label "weitere Gruppen:" -menu $selCalObj.menu.group$mid
		set currMenu $selCalObj.menu.group$mid
		menu $currMenu -font $bfnt12 -tearoff 0
		set lc 0
	    }
	}
	incr lc
	incr i
    }
    set lc 0
    set curMenu $selCalObj.menu.rooms
    set mid 0
    set anz [llength $groupList]
    set i 0
    foreach room $roomList { 
	set name [nameStrTrunc $room  $menuWidth]
	set calUserList($name) $room 
	$curMenu add command -label "  $room" -command setCurCalRooms
	if { $lc >40 } {
	    if { [expr $i+1] <$anz } {
		incr mid
		$curMenu add cascade -label "weitere Rume:" -menu $selCalObj.menu.rooms$mid
		set currMenu $selCalObj.menu.rooms$mid
		menu $currMenu -font $bfnt12 -tearoff 0
		set lc 0
	    }
	}
	incr lc
	incr i
    }
}
proc setCurCal { } {
    global selCalObj cur_Cal calUserList curCalName


    set ent [$selCalObj.menu entrycget active -label ]
    set mid 0
    while { $ent == "weitere Mitarbeiter:" } {
	incr mid
	set ent [$selCalObj.menu.sub$mid entrycget active -label ]
    }
    
#    set cur_Cal [string trim  $ent]
    set name [string trim  $ent]
    set cur_Cal $calUserList($name)
    $selCalObj configure -text [format " %s " $name]
    drawNewView
}
proc setCurCalGroup { } {
    global selCalObj cur_Cal calUserList


    set ent [$selCalObj.menu.group entrycget active -label ]
    set mid 0
    while { $ent == "weitere Gruppen:" } {
	incr mid
	set ent [$selCalObj.menu.group$mid entrycget active -label ]
    }
    
#    set cur_Cal [string trim  $ent]
    set name [string trim  $ent]
    set cur_Cal $calUserList($name)
    $selCalObj configure -text [format " %s " $name]
#    $selCalObj configure -text [format "Gruppe: %s " $cur_Cal]
    drawNewView
}
proc setCurCalRooms { } {
    global selCalObj cur_Cal calUserList


    set ent [$selCalObj.menu.rooms entrycget active -label ]
    set mid 0
    while { $ent == "weitere Rume:" } {
	incr mid
	set ent [$selCalObj.menu.rooms$mid entrycget active -label ]
    }
    
    set name [string trim  $ent]
    set cur_Cal $calUserList($name)
    $selCalObj configure -text [format " %s " $name]
#    set cur_Cal [string trim  $ent]
#    $selCalObj configure -text [format "Raum: %s " $cur_Cal]
    drawNewView
}
proc setCurCalMenuTitel { } {
    global selCalObj cur_Cal

    $selCalObj configure -text $cur_Cal
}


proc drawCalendar { } { 
#    drawUsersCalendar

    drawCal
}

proc compareCalEntries2 { c1 c2 } {
    set d1 [ lindex $c1 0]
    set t1 [ lindex $c1 1]
    set n1 [ lindex $c1 4]
    set d2 [ lindex $c2 0]
    set t2 [ lindex $c2 1]
    set n2 [ lindex $c2 4]

    set r 0
    
#    set n [expr $n1 +$n2]

    if { $n1 ==1 } { set t1 0  }
    if { $n2 ==1 } { set t2 0  }
    
    if { $d1 > $d2} {set r  1}
    if { $d1 < $d2} {set r -1}
    if {$r == 0 } {
	if { $t1 > $t2} {set r  1}
	if { $t1 < $t2} {set r -1}
    }
    
#    puts "cmp /$c1/ vs /$c2/  =>   /$d1,$t1/ vs /$d2,$t2/   -> $r"
    return $r
}

proc compareCalEntries { c1 c2 } {
    set d1 [ lindex $c1 0]
    set t1 [ lindex $c1 1]
    set n1 [ lindex $c1 4]
    set d2 [ lindex $c2 0]
    set t2 [ lindex $c2 1]
    set n2 [ lindex $c2 4]

    set r 0

    #bei noTime verdrehtes Vorzeichen, da ganztagesTermine am Anfang stehen sollen
    if { $n1 > $n2 } { set r -1 }
    if { $n1 < $n2 } { set r  1 }
    
    if { $r == 0} {
	if { $d1 > $d2} {set r  1}
	if { $d1 < $d2} {set r -1}
    }
    if {$r == 0 } {
	# Wenn beide Termine ganztgig sind spielt die uhrzeit keine Rolle und der Time-Wert hat keine Bedeutung
	if { $n1 == 0 } {
	    if { $t1 > $t2} {set r  1}
	    if { $t1 < $t2} {set r -1}
	}
    }
#    puts "cmp /$c1/ vs /$c2/  =>   /$d1,$t1/ vs /$d2,$t2/   -> $r"
    return $r
}



proc drawUsersCalendar { } { 
    global can calDrawn cur_Cal dateTagKO prvCal
    if { $calDrawn == 1}  {
	$can delete termin
	update
    }
    set dateTagKO ""
    addUsersCalendar $cur_Cal
    set dateTagKO [lsort $dateTagKO]
#    puts "dateTagKO: $dateTagKO"
#    puts [join $dateTagKO]
    setTagList 0 [llength $dateTagKO] [join $dateTagKO]
    set calDrawn 1
    redrawMainCanvas
    _drawCurrentTime
}
proc addUsersCalendar { cur_Cal } { 
    global username wdList  can dxb dyh dxd weekCalFont eddv_repTypStr prvCal
    global dateID showIgnore  calDrawn  calDayCount groupOnlyCommon ignoreInfo
    global yOffset  dateTagKO dateByTag timeByTag
    global calKernStart calKernEnd calSplitHour calKernLen calSplitYPos
#    global dyt yday yday2 xday xday2
    global xday yday0 yday1 yday2 calDay calMon calYear calWD calStart calEnd calDayList yTitelType calLineAnz
    global calNr calDayStr calHourLineStep calLineList calJumpMode calAllDayList calAllDayList2 calStrList
    global calSplitOffset calGlobalSlots

    puts "->>> $ignoreInfo"
    set dateNr 0

    doLock
    set colorRing "#FFF0A0 #A0FFF0 #F0A0FF #FFFFFF #FFFFA0 #FFA0FF #A0FFFF #FFC0C0 #C0FFC0 #C0C0FF"
    set priorityRing "black purple4 blue4 green4 green2 yellow2 orange red"

    set first [ lindex $calStrList 0]
    set last [ lindex $calStrList end]
    set calList [request getUserCal $username  $cur_Cal $first $last  $showIgnore $ignoreInfo [expr 1 - $groupOnlyCommon] ]
    if { [string first $calList "ServerDown"] >=0 } {ServerDownDialog}
    
    set calList [lsort -command compareCalEntries $calList]
    set anz [llength $calList]

    set maxlevel 1
    for {set i 0} { $i < $anz } { incr i } { 
	set level($i) 1
	set maxLevel($i) 1
	set grp($i) 0
    }
#Erstmal die ganztages Termine
    set gdList ""
    for { set i 0 } {$i< $anz} {incr i} {
	set date [lindex $calList $i ]
	set startD [lindex $date 0]
	set stopD [lindex $date 2]
	set noTime [lindex $date 4]
	if { $noTime == 1} { 
	    set startIdx [lsearch $calStrList $startD]
	    set stopIdx [lsearch $calStrList $stopD]
#	    puts ">>> $startD $stopD ==> $startIdx $stopIdx"
	    for {set idx $startIdx } {$idx <= $stopIdx} {incr idx} {
		set dat [ lindex $calStrList $idx ]
#		puts "   -> $idx = $dat"
		lappend gdList $dat
	    }
	}
    }
    foreach date $gdList { set gdCount($date) 0}
#    puts $gdList
    for { set i 0 } {$i< $anz} {incr i} {
	set date [lindex $calList $i ]
	set startD [lindex $date 0]
	set stopD [lindex $date 2]
	set noTime [lindex $date 4]
	if { $noTime == 1} { 
	    set startIdx [lsearch $calStrList $startD]
	    set stopIdx [lsearch $calStrList $stopD]
#	    puts ">>> $startD $stopD ==> $startIdx $stopIdx"
	    for {set idx $startIdx } {$idx <= $stopIdx} {incr idx} {
		set dat [ lindex $calStrList $idx ]
#		puts "   -> $idx = $dat"
		set level($i-$dat) $gdCount($dat)
		incr gdCount($dat)
	    }
	}
    }
    set baseHour [expr -1*$calGlobalSlots]
    set gLen [expr 60 *$calGlobalSlots]


#Suche nach parrallel Terminen    
    set activeList ""
    set lastGroupD -9999999
    set lastGroupT -9999
    for { set i 0 } {$i<=8} {incr i} {
	set lastD($i) -9999999
	set lastT($i) -9999
    }
    set depth 1
    for {set i 0} { $i < $anz } { incr i } {
	set date [lindex $calList $i ]
	set startD [lindex $date 0]
	set startT [lindex $date 1]
	set stopD  [lindex $date 2]
	set stopT  [lindex $date 3]
	set noTime [lindex $date 4]
	set titel  [lindex $date 5]
	set did    [lindex $date 6]
	set prior  [lindex $date 8]

	if {$noTime == 1 } { continue }


	# Gehrt dieser Termin zur selben Gruppe wie der letzte
	if { [ isDate1GreaterThanDate2 $lastGroupD $lastGroupT $startD $startT] >0 } {
	    lappend activeList $i
	    #finde eine Spur/Level in der der aktuelle Termin passt
	    set spur -1
	    for { set l 1} {$l<=$depth} {incr l} {
		if { [isDate1GreaterThanDate2 $startD $startT $lastD($l) $lastT($l) ] > 0 } {
		    set spur $l
		    break
		}
	    }
	    #keine passende Spur gefunden ? Dann fge eine neue Spur hinzu
	    if { $spur == -1 } {
		incr depth
		set spur $depth
	    }
	    set lastD($spur) $stopD
	    set lastT($spur) $stopT
	    if { [ isDate1GreaterThanDate2 $stopD $stopT $lastGroupD $lastGroupT ] >0 } {
		set lastGroupD $stopD
		set lastGroupT $stopT
	    }
	    set level($i) [expr  $spur -1]
	} else {
	    #Dieser Termin gehrt einer neuen Gruppe an
	    #Ist eine vorherige Gruppe zu schliessen
	    if { [llength $activeList] >0 } {
		foreach ent $activeList {
		    set maxLevel($ent) $depth
		}
		set activeList ""
		set depth 1
	    }


	    lappend activeList $i
	    set lastGroupD $stopD
	    set lastGroupT $stopT
	    set lastD(1) $stopD
	    set lastT(1) $stopT
	    set level($i) 0
	}
    }
    #Die letzte Gruppe noch schliessen
    if { [llength $activeList] >0 } {
	foreach ent $activeList {
	    set maxLevel($ent) $depth
	}
    }


    set tc 0
    set dx [expr $dxd  -1]
    for {set i 0 } { $i < $anz } { incr i} {
	set date [lindex $calList $i ]
	set startD [lindex $date 0]
	set startT [lindex $date 1]
	set stopD  [lindex $date 2]
	set stopT  [lindex $date 3]
	set noTime [lindex $date 4]
	set titel  [lindex $date 5]
	set did    [lindex $date 6]
	set repTyp [lindex $date 7]
	set prior  [lindex $date 8]

	set startIdx [lsearch $calStrList $startD]
	set stopIdx [lsearch $calStrList $stopD]
	for {set idx $startIdx } {$idx <= $stopIdx} {incr idx} {
	    set list [lindex $calAllDayList $idx]
	    set lin  [lindex $list 0]
	    set dt   [lindex $list 1]
	    set lcid "$calNr-$lin-$dt"
	    set  cid "$calNr-$lin"

	    if { $noTime == 1 } {
                set date [lindex $calStrList $idx]
 		set w [ expr double($gLen)/$gdCount($date)]
		set startM [ expr int(floor( $w *$level($i-$date)))]
		set stopM  [expr int(floor( $w *$level($i-$date) +$w))]
		set startT [expr $baseHour *100]
		set stopT $startT
		set startH $baseHour
		set stopH $startH
		
		while { $startM>0} {
		    incr startM -60
		    incr startT 100
		    incr startH
		}
		incr startT $startM
		while { $stopM>0} {
		    incr stopM -60
		    incr stopT 100
		    incr stopH
		}
		incr stopT $stopM
		set x1 [expr $xday($lcid) + 1]
		set x2 [expr $x1  + $dxd-1]
#		puts "GT: $date: $startT - $stopT $x1 $x2"
		set list "{$startH $startM $stopH $stopM}"
	    } else {
		if { $idx == $startIdx} {
		    set t0 $startT
		} else {
		    set t0 0
		}
		if { $idx == $stopIdx} {
		    set t1 $stopT
		} else {
		    set t1 2359
		}
		set w [expr int (floor(double($dx) /$maxLevel($i)))]

		set x1 [expr $xday($lcid) + $level($i) *$w +1]
		set x2 [expr $x1  + $w-1]
		
		set min1  [ expr $t0 % 100 ]
		set hour1 [ expr ($t0-$min1)/100 ]
		set min2  [ expr $t1 % 100 ]
		set hour2 [ expr ($t1-$min2)/100 ]

		if { $hour1 < $calSplitHour && $hour2 > $calSplitHour} {
		    set list "{$hour1 $min1 $calSplitHour 0} {$calSplitHour 0 $hour2 $min2}"
		} elseif { $hour1 < $calSplitHour && $hour2 == $calSplitHour && $min2 >0 } {
		    set list "{$hour1 $min1 $calSplitHour 0} {$calSplitHour 0 $hour2 $min2}"
		} else {
		    set list "{$hour1 $min1 $hour2 $min2}"
		}
	    }
#	    puts "<<<<$list>>>>$calSplitHour"
	    foreach ent $list {
#		puts ">>>$ent<<<"
		set yShift 0
		set hour [lindex $ent 0]
		set min  [lindex $ent 1]
		if { $hour >= $calSplitHour } {
		    set list [lindex $calAllDayList2 $idx]
		    set lin  [lindex $list 0]
		    set dt   [lindex $list 1]
		    set lcid "$calNr-$lin-$dt"
		    set  cid "$calNr-$lin"
		    set yShift $calSplitOffset($lcid)
		} 
		set yb0 [expr $yday2($cid) - $yShift]
		set yb1 [expr $yb0 +$calKernStart * $dyh]
		set yb2 [expr $yb1 +$calKernLen *$dyh*2 ]
		if { $noTime == 1} {
		    set x1 [expr $xday($lcid) +1]
		    set x2 [expr $x1  + $dxd-1]
		} else {
		    set x1 [expr $xday($lcid) + $level($i) *$w +1]
		    set x2 [expr $x1  + $w-1]
		}
#		puts "$lcid: $yday2($cid) $dyh"

		if { $hour < $calKernStart } {
		    set y1 [expr $yb0 +$hour* $dyh +  int((double($min)/60)*$dyh) ]
		} elseif { $hour < $calKernEnd } {
		    set y1 [expr $yb1 +($hour-$calKernStart)*$dyh *2+ int((double($min)/30)*$dyh) ]
		} else {
		    set y1 [expr $yb2 +($hour-$calKernEnd)*$dyh + int((double($min)/60)*$dyh)]
		}
#		puts "1: ($hour $min) -> $y1 ($yb0 $yb1 $yb2 $dyh $yShift)"

		set hour [lindex $ent 2]
		set min  [lindex $ent 3]
		if { $hour < $calKernStart } {
		    set y2 [expr $yb0 + $hour* $dyh +  int((double($min)/60)*$dyh) ]
		} elseif { $hour < $calKernEnd } {
		    set y2 [expr $yb1 +($hour-$calKernStart)*$dyh*2 + int((double($min)/30)*$dyh) ]
		} else {
		    set y2 [expr $yb2 + ($hour-$calKernEnd)* $dyh +  int((double($min)/60)*$dyh) ]
		}
		if { [expr $y2 -$y1] < 6 } {
		    set y2 [ expr $y1+6]
		}
		
		incr y1
#		set dtag "term$did"
		set dtag "term$dateNr"
		incr dateNr
		$can create rectangle $x1 $y1 $x2 $y2 -fill [lindex $colorRing [expr $level($i) %10] ] -tag "$dtag termin" 
		$can create line $x1 [expr $y1+1] $x2 [expr $y1+1] -width 2 -fill [lindex $priorityRing $prior] -tag "$dtag termin"
		$can create line $x1 [expr $y2-1] $x2 [expr $y2-1] -width 2 -fill [lindex $priorityRing $prior] -tag "$dtag termin"
		set tagKO "$dtag $x1 $y1 $x2 $y2"
		lappend dateTagKO $tagKO
		
		set weekCalFont -*-helvetica-medium-r-*-*-10-*-*-*-*-*-*-*
		if {$repTyp >0 && [expr $y2-$y1]>20 } {
		    set str [format "%s\n(%s)" $titel [lindex $eddv_repTypStr $repTyp]]
		} else { 
		    set str $titel
		}
		if { [expr $y2-$y1] < 12 } {
		    set str ""
		}
		incr x1 
		incr y1
		set tag2 "txt-$lcid-$tc"
#		puts "$titel -> $str  / $tag2 $lcid $tc"
		if { $str != "" } {
		    $can create text $x1 $y1 -anchor nw -text  $str -width $w -font $weekCalFont -tag "$dtag termin $tag2"
		    incr tc
		}
		
		set tlen [string length $str]
#		puts [format "y2=$y2 , txt=%s" [$can bbox termt$did ] ]
 		if { [expr [lindex [$can bbox $tag2 ] 3 ] - $y2] > 1 } {
 		    while { [expr [lindex [$can bbox $tag2 ] 3 ] - $y2] > 1 } {
 			$can dchars $tag2 $tlen
 			incr tlen -1
 			if { $tlen <=0} { break }
 		    }
 		    if {$tlen >5} {
 			$can insert $tag2 end " ..."
			while { [expr [lindex [$can bbox $tag2 ] 3 ] - $y2] > 1 } {
			    $can dchars $tag2 $tlen
			    incr tlen -1
			    if { $tlen <=0} { break }
			}

# 			$can dchars termt$did [expr $tlen -1] end
# 			$can insert termt$did end "..."
 		    }
 		}
	    }
	    set dateID($dtag) $did
	    set dateByTag($dtag) $startD
	    set timeByTag($dtag) $startT
#	    puts "TAG: $dtag -> $timeByTag($dtag) $dateByTag($dtag)"
#	    puts "termt$did <- $did /$titel/ $x1 $y1  "
	    $can bind $dtag <ButtonRelease> {modifyDate %x %y %b }
	}	
    }
    unLock
}

proc drawCalItem { } {
}

proc drawCurrentTime { } {
    global lastRefresh

    set curTime [ currentDateTime ]
#    puts "cutTime: $curTime $lastRefresh"
    set min  [string trimleft [lindex $curTime 2 ] 0]
    if {$min  == "" } {set min 0}
    if { [expr $min %5 ] != 0 } { 
	set waitTime 60000
	set refIncr 1
    } else {
	set waitTime 300000
	set refIncr 5
    }
    _drawCurrentTime 
    if { $lastRefresh >  15 } {
	drawNewView
	set lastRefresh 0
    }
    incr lastRefresh $refIncr
    after $waitTime drawCurrentTime

}
proc _drawCurrentTime { } {
    global curTimeMark wdList xday dxd can dyh  calSplitHour xday2 yOffList yOffList2 yOffAnz 
    global calKernStart calKernEnd calKernLen calStrList
    global calAnz calStrList calAllDayList calAllDayList2 yday2 calSplitOffset

    set curTime [ currentDateTime ]
    set min  [string trimleft [lindex $curTime 2 ] 0]
    if {$min  == "" } {set min 0}
    set idx [ lsearch $calStrList [lindex $curTime 0 ] ]
#    #FIXME
#    return
    if { $idx >=0 } {
	if {$curTimeMark == 1} {
	    $can delete curTime
	}

	for {set i 0} {$i<$calAnz} {incr i} {
	    set hour [lindex $curTime 1 ]
	    if {$hour == "00" } {
		set hour 0
	    } else {
		set hour [string trimleft [lindex $curTime 1 ] 0]
	    }
	    if { $hour >= $calSplitHour } {
		set list [lindex $calAllDayList2 $idx]
		set cid [format "%d-%d" $i [lindex $list 0] ]
		set lcid [format "%d-%d-%d" $i [lindex $list 0] [lindex $list 1]]
		set yShift $calSplitOffset($lcid)
	    } else {
		set list [lindex $calAllDayList $idx]
		set cid [format "%d-%d" $i [lindex $list 0] ]
		set lcid [format "%d-%d-%d" $i [lindex $list 0] [lindex $list 1]]
		set yShift 0
	    }
	    
	    set x0 [expr $xday($lcid) +11 ]
	    set x1 [ expr $x0 +1  ]
	    set x2 [expr $x0 +$dxd -21]
	    set x3 [ expr $x2 -1  ]
	    set y0 [expr $yday2($cid) -$yShift]

	    
	    if { $hour <$calKernStart } {
		set y  [expr $y0 + $hour* $dyh +  int((double($min)/60)*$dyh) ]
	    } elseif { $hour < $calKernEnd } {
		set y0 [expr $y0 + $calKernStart*$dyh]
		set y  [expr $y0 + ($hour-$calKernStart)* $dyh *2+ int((double($min)/30)*$dyh) ]
	    } else {
		set y0 [expr $y0 +($calKernLen)*$dyh*2 +$calKernStart*$dyh ]
		set y  [expr $y0 + ($hour-$calKernEnd)* $dyh + int((double($min)/60)*$dyh)]
	    }

	    $can create line $x0 $y $x1 $y -fill red -tag curTime -arrow first -arrowshape "-12 -12 3" -width 1
	    $can create line $x2 $y $x3 $y -fill red -tag curTime -arrow first -arrowshape "-12 -12 3" -width 1
	}
	set curTimeMark 1
    }
}

proc redrawMainCanvas { } {
    global can xmax ymax refreshEna

    if { $refreshEna == 1 } {
	set x [winfo rootx $can]
	set y [winfo rooty $can]
	set geo [format "%dx%d+%d+%d"  $xmax $ymax $x $y ]
	
#	exec xrefresh  -geometry $geo
	update
	after 100
    }
#    puts "xrefresh"
}

proc modifyDate { x y b} {
    global can dateID username del_tag eddLock canParent ysmax dateByTag timeByTag

#    puts "lock = $eddLock"
    set y  [ $can canvasy $y]

     update
#     puts [format " >>> exists edd? %d" [ winfo exists .edd] ]
     if { [winfo exists .edd ] == 0 } {
	 #    if { $eddLock == 0} {}

	set eddLock 1
	set tag [getTag 0 $x $y]
	if { $tag != ""} {
	    set did -1
	    catch {set did $dateID($tag)}
#	    puts stdout [format "ev-req for : %s -> %d" $tag $did ]
	    if { $did >=0} {
#		puts "->>> $tag -->>  $did  / $dateByTag($tag) $timeByTag($tag)"
		if { $b == 3} {
		    set del_tag $tag
		    viewDate $did $dateByTag($tag) $timeByTag($tag)
		}
		if { $b == 1} {
		    editDate $did
		}
	    } else {
		set eddLock 0
	    }
	}
    }
}


proc deleteDialog {  } {
    global dateID del_tag can del_did


    toplevel .dd
    frame .dd.t -relief raised -bd 1
    frame .dd.b 
    pack .dd.t  -side top -fill x
    pack  .dd.b -side top -fill x -padx 2 -pady 4

    set del_did $dateID($del_tag)
    if { [string range $del_tag 0 3] ==  "term" } {
	set dtag $del_tag
    } else {
	set dtag [format "term%s" [string range $del_tag 3 end] ]
    }
#    puts stdout "$del_tag -> $dtag"
    message .dd.t.msg -text [ format "Wollen sie wirklich den Termin '%s' lsschen ?" [$can itemcget $dtag -text ]] -width 240
    pack .dd.t.msg -fill x
    button .dd.b.abb -text " Abbruch " -command {closeWin .dd}
    button .dd.b.del -text " Lschen " -command {doDeleteDate}
    pack .dd.b.abb -side left
    pack .dd.b.del -side right
    centerWin .dd 256 80
    update
    grab .dd
    

}
proc doDeleteDate {  } {
    global del_did username
    set ret [request deleteDate $del_did $username]
    if { [string first $ret "ServerDown"] >=0 } {ServerDownDialog}
    if { [string range $ret 0 2] =="ERR"} {
	ErrorDialog [string range $ret 3 end]
    } else {
	drawUsersCalendar
    }
    closeWin .dd
}
proc doSuspendDate {  } {
    global del_did username del_tag
    global dateByTag timeByTag

    set ret [request suspendDate $del_did $username $dateByTag($del_tag) $timeByTag($del_tag) ]
    if { [string first $ret "ServerDown"] >=0 } {ServerDownDialog}
    if { [string range $ret 0 2] =="ERR"} {
	ErrorDialog [string range $ret 3 end]
    } else {
	drawUsersCalendar
    }
    closeWin .dd
}

proc isDate1GreaterThanDate2 {d1 t1 d2 t2 } {
    if { $d1 >  $d2 } { 
	return 1
    }
    if { $d1 == $d2 } {
	if { $t1 > $t2 } { return 2}
    }

    return 0	
}

proc changeDate { step } {
    global monlen
    global curDay curMon curYear curOffset

#    puts -nonewline  "$curDay $curMon $curYear --> "
    set datum [ calcDate $curDay $curMon $curYear $step]
    set curDay  [lindex $datum 0]
    set curMon  [lindex $datum 1]
    set curYear [lindex $datum 2]

#    puts "$step ---> $curDay $curMon $curYear "
    drawCal
}

proc changeDateByMonth { step } {
    global curDay curMon curYear curOffset

    incr curMon $step
    while { $curMon >12} {
	incr curYear
	incr curMon -12
    }
    while { $curMon <1} {
	incr curYear -1
	incr curMon 12
    }
    drawCal
}  

proc calcDate { day mon year step} {
    global monlen curOffset

    incr day  $step
    set curOffset [expr ($curOffset  +$step +14) % 7 ]

    set extend 0
    if { $day > [lindex $monlen $mon] } {
	if { $mon == 2} {
	    if { [ expr $year % 4] == 4 } {
		if { $day<=29 } { set extend 1} } }
	if { $extend == 0 } { 
	    set day [expr $day - [lindex $monlen $mon]]
	    incr mon
	    if { $mon > 12 } {
		incr year
		set mon 0
	    }
	}
    }

    if { $day <1 } {
	incr mon -1
	if { $mon <0 } {
	    incr year -1
	    set mon 12
	}
	set day [ expr $day + [lindex $monlen $mon] ]
	if { $mon == 2} {
	    if { [ expr $year % 4] == 4 } {
		if { $day<=29 } { incr day} } }
    }
    return "$day $mon $year"
}

# proc tstBind { ev} {
#     puts "-> '$ev'"
# }

proc canAddDateKO { x y } {
    global dxd eddLock

#    puts "canAddDateKO $x $y"
     update
#     puts [format " >>> exists edd? %d" [ winfo exists .edd] ]
     if { [winfo exists .edd ] == 0 } {
	 #    if { $eddLock == 0} {}
	set idx [expr int(floor(double($x - 40) /$dxd)) ]
	canAddDate $y $idx 
    }
}

proc canAddDate { x y } {
    global wdList dyh username eddLock yOffAnz yOffList  can yday yday2
    global calKernStart calKernEnd calKernLen calDayStr yday2 calSplitOffset
    global groupList userList cur_Cal calUserName

#    puts "canAddDate  $x $y $eddLock"

     update
#     puts [format " >>> exists edd? %d" [ winfo exists .edd] ]
     if { [winfo exists .edd ] == 0 } {
#	 if { $eddLock == 0 } {}
#	set eddLock 1
	set y  [ $can canvasy $y]
	set tag [getTag 1 $x $y]

	set kind [string range $tag 0 1]
	set lcid [ string range $tag 2 end]
	set pos [ string last "-" $lcid ]
	set cid  [ string range $lcid 0 [expr $pos-1] ]
	set pos [ string first "-" $lcid ]
	set calNr  [ string range $lcid 0 [expr $pos-1] ]
	
#	puts "$tag -> $lcid $cid $calNr $kind"
	    
	if { $kind == "wd" } {
	    set yk    [expr $y -$yday2($cid) + $calSplitOffset($lcid)] 
	    set ym(0) [expr 0  + $calKernStart*$dyh ]
	    set ym(1) [expr $ym(0) + ($calKernLen)*$dyh  * 2]
	    set ym(2) [expr $ym(1) + (24-$calKernEnd)*$dyh]
	    set yb(0) 0
	    set yb(1) $ym(0)
	    set yb(2) $ym(1)
	    set dy(0) $dyh
	    set dy(1) [expr $dyh  * 2]
	    set dy(2) $dyh
	    set hb(0) 0
	    set hb(1) $calKernStart
	    set hb(2) $calKernEnd
#	    puts "$y , $cid , $yday2($cid) => $yk"
#	    puts "=> $ym(0)  $ym(1) $ym(2) // $dy(0)  $dy(1) $dy(2) //$hb(0)  $hb(1) $hb(2)"
	    for { set i 0 } { $i <3} {incr i} {
		if {$yk<$ym($i)} {
		    set h [expr double($yk - $yb($i))/$dy($i) +$hb($i) ]
#		    puts "$i: hour=$h"
		    set hour [ expr int(floor($h)) ]
		    set min  [ expr int(floor(($h-$hour) *4+.5))*15 ]
		    break
		}
	    }
	    if {$username == $cur_Cal } {
		newDate $username  $calDayStr($lcid) [format "%2d%02d" $hour $min]
	    } else {
		if { [ lsearch $userList $calUserName($calNr)] >=0 } {
		    invite $username  $calUserName($calNr) u $calDayStr($lcid) [format "%2d%02d" $hour $min]
		} elseif { [ lsearch $groupList $calUserName($calNr)] >=0 } {
		    invite $username  $calUserName($calNr) g $calDayStr($lcid) [format "%2d%02d" $hour $min]
		}
	    }
	} elseif { $kind == "gd" } {
	    if {$username == $cur_Cal } {
		newDate $username  $calDayStr($lcid) -1
	    } else {
		if { [ lsearch $userList $calUserName($calNr)] >=0 } {
		    invite $username  $calUserName($calNr) u $calDayStr($lcid) -1
		} elseif { [ lsearch $groupList $calUserName($calNr)] >=0 } {
		    invite $username  $calUserName($calNr) g $calDayStr($lcid) -1
		}
	    }
	    
	} elseif {$kind == "jt" } {
	    global calDay calMon calYear calTyp
	    global curDay curMon curYear
	    set curDay  $calDay($lcid)
	    set curMon  $calMon($lcid)
	    set curYear $calYear($lcid)
	    set calTyp d
	    drawCal
	}


#	newDate $username  [lindex $wdList $idx] [format "%2d%02d" $hour $min]
    }
}
