#! /bin/sh 


echo
echo "STARTE MINKOWSKY-SERVER-INSTALLTION"*
echo

echo -n "Installation-Pfad [/opt/minkowsky]   "
read ans
INSTALL_PATH=`echo $ans|awk '{if(NF>=1){print $1}else{print "/opt/minkowsky"}}'`

echo
echo -n "Wo sollen die Termine usw. abgelegt werden? [$INSTALL_PATH/share] "
read ans
if [ "$ans" == "" ]
then
    DATA_DIR=$INSTALL_PATH/share
else
    DATA_DIR=$ans
fi

echo
echo "In Einladungs und Erinnerungmails, die von Minkowsky"
echo "verschickt werden erscheint u.a. der Name der desjenigen"
echo "bei dem Minkwosky luft. Die kann der Name der Firma sein,"
echo "oder auch der Name der Familie auf dessen Privatrechener"
echo "Minkowsky luft. Dieser Text kann jederzeit in der:"
echo "Konfiguartionsdatei /etc/minkowsky gendert werden." 
echo -n "Welcher Text soll als Absender erscheinen: []  "
read COMPANY

echo
echo "Welcher Address soll bei Erinnerungsmails als"
echo  -n "Reply addresse angegeben werden: [] "
read REPLY

echo
echo
echo "Installationverzeichnis  : $INSTALL_PATH"
echo "Datenverzecihnis         : $DATA_DIR"
echo "Absendertext             : $COMPANY"
echo "Replyaddresse            : $REPLY"
echo
echo -n "Stimmen diese Angaben  [j] "
read ans
OK=`echo $ans|awk '{if(NF>=1){if($1=="j" ||$1=="J" ||$1=="y" ||$1=="Y"){print "OK"}else {print "new"}}else{print "OK"}}'`

if [ "$OK" != "OK" ]
then
    echo
    echo "OK. Versuchen wir es noch einmal"
    echo
    echo
    ./installer.sh
    exit
fi


if [ ! -d $DATA_DIR ]
then
    if [ -f $DATA_DIR ]
    then
	echo "Can't create $DATA_DIR"
	echo "File exists and is not directory"
	exit
    fi
    mkdirhier $DATA_DIR
fi

echo
echo "creating Makefile"

echo "INSTALL_PATH=$INSTALL_PATH/server" >Makefile
echo "DOCU_DIR=$INSTALL_PATH/server/docu" >>Makefile
echo >>Makefile
cat Makefile.base >>Makefile








echo
echo "Installing Server"|
echo

make install






echo
echo "making Configuration-file"

if [ -f /etc/minkowsky ]
then
    cat /etc/minkowsky |egrep  "^MINKO" > /tmp/minkowsky
else
    touch /tmp/minkowsky
fi

cat /tmp/minkowsky

echo SERVER_BIN_PATH $INSTALL_PATH/server >>/tmp/minkowsky
echo TERMIN_DATA_PATH $DATA_DIR >>/tmp/minkowsky
echo 
if [ "$COMPANY" != "" ]
then
    echo COMPANY $COMPANY>>/tmp/minkowsky
fi
echo MYSELF Minkowsky Raum/Zeit-Verwaltung >>/tmp/minkowsky
echo "REPLY_ADDRESS $REPLY"  >>/tmp/minkowsky

mv -f  /tmp/minkowsky /etc/minkowsky 
chmod a+r /etc/minkowsky 



if [ ! -f $DATA_DIR/users ]
then
    cp defaults/users $DATA_DIR/
    echo "INFO:"
    echo "Da noch keine Benuzterdatei existiert"
    echo "wurde eine mit dem Benutzer  'admin' angelegt"
fi
if [ ! -f $DATA_DIR/groups ]
then
    cp defaults/groups $DATA_DIR/
    echo "INFO:"
    echo "Da noch keine Gruppendatei existiert"
    echo "wurde eine mit der Grupe  'alle' angelegt"
fi
if [ ! -f $DATA_DIR/rooms ]
then
    cp defaults/rooms $DATA_DIR/
    echo "INFO:"
    echo "Da noch keine Raum-Datei existiert"
    echo "wurde eine mit dem Raum  'zu Hause' angelegt"
fi

if [ ! -d $DATA_DIR/prefs ]
then
    if [  -f $DATA_DIR/prefs ]
    then
	mv $DATA_DIR/prefs $DATA_DIR/prefs.bak
    fi
    mkdir $DATA_DIR/prefs
fi



echo
echo "making StartSkript"

echo "#!/bin/sh" > rcmsh
echo "MINKO_BIN=\"$INSTALL_PATH/server/mserver\"" >>rcm.sh
cat  rcminkowsky |gawk 'BEGIN{f=0}{if(f==1){print $0}; if($0 ~/^MINKO/){f=1}}' >> rcm.sh
cp rcm.sh /etc/rc.d/minkowsky
cd /etc/rc.d/rc2.d
ln -sf "../minkowsky" S99minkowsky
ln -sf "../minkowsky" K00minkowsky
cd /etc/rc.d/rc3.d
ln -sf "../minkowsky" S99minkowsky
ln -sf "../minkowsky" K00minkowsky
cd /etc/rc.d/rc5.d
ln -sf "../minkowsky" S99minkowsky
ln -sf "../minkowsky" K00minkowsky
chmod 744 /etc/rc.d/minkowsky 
echo
echo
echo "Installation des Minkowsky-Clients abgeschlossen"
echo
exit
